> For the complete documentation index, see [llms.txt](https://docs.ston.fi/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ston.fi/developer-section/dex/smart-contracts/v2/vault.md).

# Vault

Check [examples](/developer-section/dex/smart-contracts/v2/examples/vault.md) for in-depth message flow.

## Off-chain get methods

### `get_vault_data`

Returns `Vault` data

```
(slice, slice, slice, int) get_vault_data() method_id;
```

#### **Arguments**

`None`

#### **Result**

Returns `VaultData` structure containing current state of the `Vault`.

**`VaultData` structure**

| Key                | Type      | Index | Description                                      |
| ------------------ | --------- | ----- | ------------------------------------------------ |
| `owner_address`    | `address` | 0     | Owner of this `Vault`                            |
| `token_address`    | `address` | 1     | Address of `Router`'s jetton wallet for s token' |
| `router_address`   | `address` | 2     | `Router`'s address                               |
| `deposited_amount` | `bigint`  | 3     | Amount of tokens collected                       |

## Any operation handlers

Handles calls from unspecified addresses

### `withdraw_fee` (0x354bcdf4)

Send collected tokens to the owner of the `Vault`.

#### **TL-B**

```
withdraw_fee#354bcdf4 query_id:uint64 = InternalMsgBody;
```

#### **Message body**

| Name       | Type     | Description    |
| ---------- | -------- | -------------- |
| `op`       | `uint32` | Operation code |
| `query_id` | `uint64` | Query id       |

#### **Outgoing messages**

Sends a message with `vault_pay_to` op code to the router contract with the amount of token to be payed.

## Internal message handlers

Handles calls from the `Router`

### `deposit_ref_fee` (0x0490f09b)

Increase ref fee tracker for the user.

#### **TL-B**

```
deposit_ref_fee#490f09b query_id:uint64 jetton_amount:Coins excesses_address:MsgAddress = InternalMsgBody;
```

#### **Message body**

| Name               | Type      | Description                     |
| ------------------ | --------- | ------------------------------- |
| `op`               | `uint32`  | Operation code                  |
| `query_id`         | `uint64`  | Query id                        |
| `jetton_amount`    | `bigint`  | Amount of the tokens            |
| `excesses_address` | `address` | Address to receive TON excesses |

#### **Outgoing messages**

Sends excesses to `excesses_address`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ston.fi/developer-section/dex/smart-contracts/v2/vault.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
